//+------------------------------------------------------------------+
//|                                                   C_Controls.mqh |
//|                                                      Daniel Jose |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Daniel Jose"
//+------------------------------------------------------------------+
#include "Support\Interprocess.mqh"
//+------------------------------------------------------------------+
#define def_ButtonPlay 			"Images\\Market Replay\\Play.bmp"
#define def_ButtonPause			"Images\\Market Replay\\Pause.bmp"
#define def_ButtonLeft			"Images\\Market Replay\\Left.bmp"
#define def_ButtonLeftBlock 	"Images\\Market Replay\\Left_Block.bmp"
#define def_ButtonRight 		"Images\\Market Replay\\Right.bmp"
#define def_ButtonRightBlock 	"Images\\Market Replay\\Right_Block.bmp"
#define def_ButtonPin			"Images\\Market Replay\\Pin.bmp"
#define def_ButtonWait			"Images\\Market Replay\\Wait.bmp"
#resource "\\" + def_ButtonPlay
#resource "\\" + def_ButtonPause
#resource "\\" + def_ButtonLeft
#resource "\\" + def_ButtonLeftBlock
#resource "\\" + def_ButtonRight
#resource "\\" + def_ButtonRightBlock
#resource "\\" + def_ButtonPin
#resource "\\" + def_ButtonWait
//+------------------------------------------------------------------+
#define def_PrefixObjectName 	"Market Replay _ "
#define def_NameObjectsSlider	def_PrefixObjectName + "Slider"
#define def_PosXObjects			120
//+------------------------------------------------------------------+
#include "..\Auxiliar\C_Terminal.mqh"
#include "..\Auxiliar\C_Mouse.mqh"
//+------------------------------------------------------------------+
#define def_AcessTerminal (*Terminal)
#define def_InfoTerminal def_AcessTerminal.GetInfoTerminal()
//+------------------------------------------------------------------+
class C_Controls : protected C_Mouse
{
	protected:
		enum EventCustom {ev_WaitOn, ev_WaitOff};
	private	:
//+------------------------------------------------------------------+
		string	m_szBtnPlay;
		bool		m_bWait;
		struct st_00
		{
			string 	szBtnLeft,
						szBtnRight,
						szBtnPin,
						szBarSlider,
						szBarSliderBlock;
			int		posPinSlider,
						posY,
						Minimal;
		}m_Slider;
		C_Terminal *Terminal;
//+------------------------------------------------------------------+
inline void CreateObjectBitMap(int x, int y, string szName, string Resource1, string Resource2 = NULL)
			{
				ObjectCreate(def_InfoTerminal.ID, szName, OBJ_BITMAP_LABEL, 0, 0, 0);
				ObjectSetInteger(def_InfoTerminal.ID, szName, OBJPROP_XDISTANCE, def_PosXObjects + x);
				ObjectSetInteger(def_InfoTerminal.ID, szName, OBJPROP_YDISTANCE, y);
				ObjectSetString(def_InfoTerminal.ID, szName, OBJPROP_BMPFILE, 0, "::" + Resource1);
				ObjectSetString(def_InfoTerminal.ID, szName, OBJPROP_BMPFILE, 1, "::" + (Resource2 == NULL ? Resource1 : Resource2));
				ObjectSetInteger(def_InfoTerminal.ID, szName, OBJPROP_ZORDER, 1);
			}
//+------------------------------------------------------------------+
inline void CreteBarSlider(int x, int size)
			{
				ObjectCreate(def_InfoTerminal.ID, m_Slider.szBarSlider, OBJ_RECTANGLE_LABEL, 0, 0, 0);
				ObjectSetInteger(def_InfoTerminal.ID, m_Slider.szBarSlider, OBJPROP_XDISTANCE, def_PosXObjects + x);
				ObjectSetInteger(def_InfoTerminal.ID, m_Slider.szBarSlider, OBJPROP_YDISTANCE, m_Slider.posY - 4);
				ObjectSetInteger(def_InfoTerminal.ID, m_Slider.szBarSlider, OBJPROP_XSIZE, size);
				ObjectSetInteger(def_InfoTerminal.ID, m_Slider.szBarSlider, OBJPROP_YSIZE, 9);
				ObjectSetInteger(def_InfoTerminal.ID, m_Slider.szBarSlider, OBJPROP_BGCOLOR, clrLightSkyBlue);
				ObjectSetInteger(def_InfoTerminal.ID, m_Slider.szBarSlider, OBJPROP_BORDER_COLOR, clrBlack);
				ObjectSetInteger(def_InfoTerminal.ID, m_Slider.szBarSlider, OBJPROP_WIDTH, 3);
				ObjectSetInteger(def_InfoTerminal.ID, m_Slider.szBarSlider, OBJPROP_BORDER_TYPE, BORDER_FLAT);
//---
				ObjectCreate(def_InfoTerminal.ID, m_Slider.szBarSliderBlock, OBJ_RECTANGLE_LABEL, 0, 0, 0);
				ObjectSetInteger(def_InfoTerminal.ID, m_Slider.szBarSliderBlock, OBJPROP_XDISTANCE, def_PosXObjects + x);
				ObjectSetInteger(def_InfoTerminal.ID, m_Slider.szBarSliderBlock, OBJPROP_YDISTANCE, m_Slider.posY - 9);
				ObjectSetInteger(def_InfoTerminal.ID, m_Slider.szBarSliderBlock, OBJPROP_YSIZE, 19);
				ObjectSetInteger(def_InfoTerminal.ID, m_Slider.szBarSliderBlock, OBJPROP_BGCOLOR, clrRosyBrown);
				ObjectSetInteger(def_InfoTerminal.ID, m_Slider.szBarSliderBlock, OBJPROP_BORDER_TYPE, BORDER_RAISED);
			}
//+------------------------------------------------------------------+
		void CreateBtnPlayPause(bool state)
			{
				m_szBtnPlay = def_PrefixObjectName + "Play";
				CreateObjectBitMap(0, 25, m_szBtnPlay, (m_bWait ? def_ButtonWait : def_ButtonPause), (m_bWait ? def_ButtonWait : def_ButtonPlay));
				ObjectSetInteger(def_InfoTerminal.ID, m_szBtnPlay, OBJPROP_STATE, state);
			}
//+------------------------------------------------------------------+
		void CreteCtrlSlider(void)
			{
				u_Interprocess Info;
				
				m_Slider.szBarSlider 		= def_NameObjectsSlider + " Bar";
				m_Slider.szBarSliderBlock 	= def_NameObjectsSlider + " Bar Block";
				m_Slider.szBtnLeft			= def_NameObjectsSlider + " BtnL";
				m_Slider.szBtnRight			= def_NameObjectsSlider + " BtnR";
				m_Slider.szBtnPin				= def_NameObjectsSlider + " BtnP";
				m_Slider.posY = 40;
				CreteBarSlider(77, 436);
				CreateObjectBitMap(47, 25, m_Slider.szBtnLeft, def_ButtonLeft, def_ButtonLeftBlock);
				CreateObjectBitMap(511, 25, m_Slider.szBtnRight, def_ButtonRight, def_ButtonRightBlock);
				CreateObjectBitMap(0, m_Slider.posY, m_Slider.szBtnPin, def_ButtonPin);
				ObjectSetInteger(def_InfoTerminal.ID, m_Slider.szBtnPin, OBJPROP_ANCHOR, ANCHOR_CENTER);
				if (GlobalVariableCheck(def_GlobalVariableReplay)) Info.u_Value.df_Value = GlobalVariableGet(def_GlobalVariableReplay); else Info.u_Value.df_Value = 0;
				m_Slider.Minimal = Info.s_Infos.iPosShift;
				PositionPinSlider(Info.s_Infos.iPosShift);
			}
//+------------------------------------------------------------------+
inline void RemoveCtrlSlider(void)
			{			
				ChartSetInteger(def_InfoTerminal.ID, CHART_EVENT_OBJECT_DELETE, false);
				ObjectsDeleteAll(def_InfoTerminal.ID, def_NameObjectsSlider);
				ChartSetInteger(def_InfoTerminal.ID, CHART_EVENT_OBJECT_DELETE, true);
			}
//+------------------------------------------------------------------+
inline void PositionPinSlider(int p, const int minimal = 0)
			{
				m_Slider.posPinSlider = (p < minimal ? minimal : (p > def_MaxPosSlider ? def_MaxPosSlider : p));
				m_Slider.posPinSlider = (p < m_Slider.Minimal ? m_Slider.Minimal : (p > def_MaxPosSlider ? def_MaxPosSlider : p));
				ObjectSetInteger(def_InfoTerminal.ID, m_Slider.szBtnPin, OBJPROP_XDISTANCE, m_Slider.posPinSlider + def_PosXObjects + 95);
				ObjectSetInteger(def_InfoTerminal.ID, m_Slider.szBtnLeft, OBJPROP_STATE, m_Slider.posPinSlider != minimal);
				ObjectSetInteger(def_InfoTerminal.ID, m_Slider.szBtnLeft, OBJPROP_STATE, m_Slider.posPinSlider != m_Slider.Minimal);
				ObjectSetInteger(def_InfoTerminal.ID, m_Slider.szBtnRight, OBJPROP_STATE, m_Slider.posPinSlider < def_MaxPosSlider);
				ObjectSetInteger(def_InfoTerminal.ID, m_Slider.szBarSliderBlock, OBJPROP_XSIZE, minimal + 2);
				ObjectSetInteger(def_InfoTerminal.ID, m_Slider.szBarSliderBlock, OBJPROP_XSIZE, m_Slider.Minimal + 2);
				ChartRedraw();
			}
//+------------------------------------------------------------------+
	public	:
//+------------------------------------------------------------------+
		C_Controls(C_Terminal *arg)
			:C_Mouse(arg),
			 m_bWait(false)
			{
				if (CheckPointer(Terminal = arg) == POINTER_INVALID) SetUserError(C_Terminal::ERR_PointerInvalid);
				m_szBtnPlay 			= NULL;
				m_Slider.szBarSlider = NULL;
				m_Slider.szBtnPin 	= NULL;
				m_Slider.szBtnLeft 	= NULL;
				m_Slider.szBtnRight 	= NULL;
			}
//+------------------------------------------------------------------+
		~C_Controls()
			{
				if (CheckPointer(Terminal) == POINTER_INVALID) return;
				ChartSetInteger(def_InfoTerminal.ID, CHART_EVENT_OBJECT_DELETE, false);
				ObjectsDeleteAll(def_InfoTerminal.ID, def_PrefixObjectName);
			}
//+------------------------------------------------------------------+
		void Init(const bool state)
			{
				CreateBtnPlayPause(state);
				GlobalVariableTemp(def_GlobalVariableReplay);
				if (!state) CreteCtrlSlider();
				ChartRedraw();
			}
//+------------------------------------------------------------------+
		void DispatchMessage(const int id, const long &lparam, const double &dparam, const string &sparam)
			{
				u_Interprocess Info;
				static int six = -1, sps;
				int x, y, px1, px2;
				
				C_Mouse::DispatchMessage(id, lparam, dparam, sparam);
				switch (id)
				{
					case (CHARTEVENT_CUSTOM + C_Controls::ev_WaitOn):
						if (lparam == 0) break;
						m_bWait = true;
						CreateBtnPlayPause(true);
						break;
					case (CHARTEVENT_CUSTOM + C_Controls::ev_WaitOff):
						if (lparam == 0) break;
						m_bWait = false;
						Info.u_Value.df_Value = dparam;
						CreateBtnPlayPause(Info.s_Infos.isPlay);
						break;
					case CHARTEVENT_OBJECT_DELETE:
						if (StringSubstr(sparam, 0, StringLen(def_PrefixObjectName)) == def_PrefixObjectName)
						{
							if (StringSubstr(sparam, 0, StringLen(def_NameObjectsSlider)) == def_NameObjectsSlider)
							{
								RemoveCtrlSlider();
								CreteCtrlSlider();
							}else
							{
								Info.u_Value.df_Value = GlobalVariableGet(def_GlobalVariableReplay);
								CreateBtnPlayPause(Info.s_Infos.isPlay);
							}
							ChartRedraw();
						}
						break;
					case CHARTEVENT_OBJECT_CLICK:
						if (m_bWait) break;
						if (sparam == m_szBtnPlay)
						{
							Info.s_Infos.isPlay = (bool) ObjectGetInteger(def_InfoTerminal.ID, m_szBtnPlay, OBJPROP_STATE);
							if (!Info.s_Infos.isPlay) CreteCtrlSlider(); else
							{
								RemoveCtrlSlider();
								m_Slider.szBtnPin = NULL;
							}
							Info.s_Infos.iPosShift = (ushort) m_Slider.posPinSlider;
							GlobalVariableSet(def_GlobalVariableReplay, Info.u_Value.df_Value);
							ChartRedraw();
						}else	if (sparam == m_Slider.szBtnLeft) PositionPinSlider(m_Slider.posPinSlider - 1);
						else if (sparam == m_Slider.szBtnRight) PositionPinSlider(m_Slider.posPinSlider + 1);
						break;
					case CHARTEVENT_MOUSE_MOVE:
						if (GetInfoMouse().ExecStudy) return;
						if ((CheckClick(C_Mouse::eClickLeft)) && (m_Slider.szBtnPin != NULL))
						{
							x = GetInfoMouse().Position.X;
							y = GetInfoMouse().Position.Y;
							px1 = m_Slider.posPinSlider + def_PosXObjects + 86;
							px2 = m_Slider.posPinSlider + def_PosXObjects + 114;
							if ((y >= (m_Slider.posY - 14)) && (y <= (m_Slider.posY + 14)) && (x >= px1) && (x <= px2) && (six == -1))
							{
								six = x;
								sps = m_Slider.posPinSlider;
								ChartSetInteger(def_InfoTerminal.ID, CHART_MOUSE_SCROLL, false);
							}
							if (six > 0) PositionPinSlider(sps + x - six);
						}else if (six > 0)
						{
							six = -1;
							ChartSetInteger(def_InfoTerminal.ID, CHART_MOUSE_SCROLL, true);
						}
						break;
				}
			}
//+------------------------------------------------------------------+
};
//+------------------------------------------------------------------+
#undef def_InfoTerminal
#undef def_AcessTerminal
#undef def_PosXObjects
#undef def_ButtonPlay
#undef def_ButtonPause
#undef def_ButtonLeft
#undef def_ButtonRight
#undef def_ButtonPin
#undef def_NameObjectsSlider
#undef def_PrefixObjectName
//+------------------------------------------------------------------+
